//  IoT電子工作キット sLab-Remo2
//  2-2-2.赤外線障害物センサ

// ①利用ピンの設定
const byte IR_O_PIN = 15;

// ②起動時、最初に実行される処理
void setup() {
  Serial.begin(115200);        // シリアルモニタ設定（115200bps）
  Serial.println();            // (見やすくするために改行)
  // ③IO15に出力設定
  pinMode(IR_O_PIN, INPUT);
}

// ④setup完了後、電源OFFまで繰り返し処理
void loop() {
  // ⑤LEDを点灯する
  if(digitalRead(IR_O_PIN) == HIGH) {
    Serial.println("No Detect");
  } else {
    Serial.println("Detect Obstacle");
  }
  // ⑥3秒間間隔を空けて測定
  delay(3000);
}
