// ①HTMLトップ返答処理
void sendTop( AsyncWebServerRequest *request ) {
  // ②返答HTML定義
  char *htmltop = 
  "<!doctype html><html class=\"fullscrn\"><head><meta charset=\"UTF-8\">\r\n"
  "<meta name=\"viewport\" content=\"width=device-width\">\r\n"
  "<link rel=\"icon\" href=\"http://kit.socinno.com/wp-content/uploads/2019/09/favicon.ico\">\r\n"
  "<style type=\"text/css\"><!--\r\n"
  "h1 { margin: 13px 0; font-size: 28px; line-height: 70%; }\r\n"
  "#contents { width: 100%; max-width: 320px; }\r\n"
  "footer { text-align: right; }\r\n"
  ".fullscrn { width: 100%; height: 100%; }\r\n"
  ".cosmos { color: white; background-color: #797572;\r\n"
  "background-image: linear-gradient(-173deg, rgba(255,255,255,0.20) 0%, #000000 100%),\r\n"
  "linear-gradient(72deg, rgba(255,255,255,0.25) 25%, rgba(0,0,0,0.25) 100%),\r\n"
  "radial-gradient(47% 102%, rgba(255,255,255,0.50) 0%, rgba(21,24,32,0.60) 120%);background-blend-mode: multiply; }\r\n"
  "--></style>\r\n"
  "<title>sLab-Car</title><style>@media print {#ghostery-purple-box {display:none !important}}</style><style>@media print {#ghostery-purple-box {display:none !important}}</style></head>\r\n"
  "<body class=\"cosmos fullscrn\" data-gr-c-s-loaded=\"true\"><center><div id=\"contents\"><header><h3>sLab-カメラ表示画面</h3></header>\r\n"
  "<form id=\"canform\" method=\"get\" action=\"javascript:void(0);\">\r\n"
  "<br>\r\n"
  "<div id=\"dcan1\" style=\"display: block;\"><canvas id=\"ccanvas\" width=\"176\" height=\"144\" style=\"background-color:grey; float:left\"></canvas>\r\n"
  "<span style=\"line-height:25px;text-align:center;\"><br><button id=\"startbtn\" type=\"button\" style=\"width:70px;height:25px\" onclick=\"wsConnect()\">開始</button><br>\r\n"
  "<font color=\"red\"><span id=\"msg\" style=\"vertical-align:middle;\">開始して下さい</span></font><br>\r\n"
  "<button id=\"endbtn\" type=\"button\" style=\"width:70px;height:25px\" onclick=\"wsDisconnect()\">終了</button></span><p style=\"clear: both;\"></p><br></div>\r\n"
  "<br>\r\n"
  "<footer><font size=\"-1\">Copyright© SOCINNO All rights reserved.</font></footer></form></div></center>\r\n"
  "\r\n"
  "<script language=\"javascript\" type=\"text/javascript\">\r\n"
  "var wsUri;\r\n"
  "var socket = null;\r\n"
  "var tms;\r\n"
  "var msg;\r\n"
  "var ctx;\r\n"
  "var width;\r\n"
  "var height;\r\n"
  "var imageData;\r\n"
  "var pixels;\r\n"
  "var fps = 0;\r\n"
  "var jobFlag = false;\r\n"
  "var canFlag = false;\r\n"
  "var wsFlag = false;\r\n"
  "window.onload = function(){\r\n"
  " wsUri = \"ws://\" + window.location.hostname + \":81/\";\r\n"
  " msg = document.getElementById('msg');\r\n"
  " var canv = document.getElementById('ccanvas');\r\n"
  " ctx = canv.getContext('2d');\r\n"
  " width = canv.width;\r\n"
  " height = canv.height;\r\n"
  " imageData = ctx.createImageData( width, 1 );\r\n"
  " pixels = imageData.data;\r\n"
  " var fullpath = location.href\r\n"
  " var path = fullpath.split('?');\r\n"
  " if ( path[1] && path[1] != \"\" ) {\r\n"
  "   var eachData = path[1].split('&');\r\n"
  "   for (var i = 0; i < eachData.length; i++) {\r\n"
  "     var tmpData = eachData[i].split('=');\r\n"
  "     if ( tmpData[0] == \"camera\" && tmpData[1] == \"on\" ) {\r\n"
  "       canFlag = true;\r\n"
  "     }\r\n"
  "   }\r\n"
  " }\r\n"
  " if (canFlag) {\r\n"
  "   document.getElementById(\"startbtn\").disabled = true;\r\n"
  "   setTimeout('wsConnect()', 1000);\r\n"
  " }\r\n"
  "}\r\n"
  "function Msg(message){ msg.innerHTML = message;}\r\n"
  "function wsConnect(){\r\n"
  " wsFlag = true;\r\n"
  " document.getElementById(\"startbtn\").disabled = true;\r\n"
  " tms = new Date();\r\n"
  " if(socket == null){\r\n"
  "   socket = new WebSocket(wsUri);\r\n"
  "   socket.binaryType = 'arraybuffer';\r\n"
  "   socket.onopen   = function(evt){ onOpen(evt) };\r\n"
  "   socket.onclose  = function(evt){ onClose(evt) };\r\n"
  "   socket.onmessage = function(evt){ onMessage(evt) };\r\n"
  "   socket.onerror  = function(evt){ onError(evt) };\r\n"
  " }\r\n"
  "}\r\n"
  "function wsDisconnect(){\r\n"
  " wsFlag = false;\r\n"
  " socket.close();\r\n"
  " socket = null;\r\n"
  " Msg('STOP');\r\n"
  " document.getElementById(\"startbtn\").disabled = false;\r\n"
  "}\r\n"
  "function onOpen(evt){ Msg('START');}\r\n"
  "function onClose(evt){\r\n"
  " Msg('DISCONNECT');\r\n"
  " wsClose();\r\n"
  " document.getElementById(\"startbtn\").disabled = false;\r\n"
  "}\r\n"
  "function onError(evt){\r\n"
  " Msg('Err:' + evt.data);\r\n"
  " document.getElementById(\"startbtn\").disabled = false;\r\n"
  "}\r\n"
  "function onMessage(evt){\r\n"
  " var data = evt.data;\r\n"
  " if( typeof data == 'string'){\r\n"
  "   msg.innerHTML = data;\r\n"
  " }else if( data instanceof ArrayBuffer){\r\n"
  "   drawLine(evt.data);\r\n"
  " }else if( data instanceof Blob){\r\n"
  "   Msg('Blob data received');\r\n"
  " }\r\n"
  "}\r\n"
  "function wsClose(){\r\n"
  " socket.close();\r\n"
  " socket = null;\r\n"
  " if (wsFlag) {\r\n"
  "   setTimeout('wsConnect()', 1);\r\n"
  " }\r\n"
  "}\r\n"
  "function drawLine(data){\r\n"
  " var buf = new Uint16Array(data);\r\n"
  " //console.log(\"drawLine: \" + \"%d\" + \" %d\" + \" %d\", buf[0], buf[100], buf[10000]);\r\n"
  " for(var y = 0; y < (buf.length)/width; y+=1){\r\n"
  "   var base = 0;\r\n"
  "   for(var x = 0; x < width; x += 1){\r\n"
  "     var c = x + y * width;\r\n"
  "     pixels[base+0] = (buf[c] & 0xf800) >> 8 | (buf[c] & 0xe000) >> 13;\r\n"
  "     pixels[base+1] = (buf[c] & 0x07e0) >> 3 | (buf[c] & 0x0600) >> 9;\r\n"
  "     pixels[base+2] = (buf[c] & 0x001f) << 3 | (buf[c] & 0x001c) >> 2;\r\n"
  "     pixels[base+3] = 255;\r\n"
  "     base += 4;\r\n"
  "   }\r\n"
  "   ctx.putImageData(imageData, 0, y);\r\n"
  " }\r\n"
  " if(y == height) fps+=1;\r\n"
  "}\r\n"
  "</script></body></html>\r\n"
  ;

  // ③返答HTML送信
  request->send(200, "text/html", htmltop);
}
