//  IoT電子工作キット sLab-Remo2
//  4-2-1.SPIFFSによるファイル操作1

#include <SPIFFS.h>       // ①ライブラリを読み込み

void setup(void) {
  Serial.begin(115200);   // ②Serial設定
  Serial.println ("");

  SPIFFS.begin();         // ③SPIFFS開始
  
  String wrfile = "/spiffs_test.txt";  // ④読み書きするファイル名を設定
  String writeStr = "This is SPIFFS test!";   // ⑤書き込み文字列を設定
  File fw = SPIFFS.open(wrfile.c_str(), "w"); // ⑥ファイルを書き込みモードで開く
  fw.println( writeStr );         // ⑦ファイルに書き込み
  fw.close();                     // ⑧ファイルを閉じる
  Serial.print("SPIFFS Write:");  // ⑨書き込み完了をモニタに表示
  Serial.println(writeStr);
  delay(1000);

  File fr = SPIFFS.open(wrfile.c_str(), "r"); // ⑩ファイルを読み込みモードで開く
  String readStr = fr.readStringUntil('\n');  // ⑪改行まで１行読み出し
  fr.close();                         // ⑫ファイルを閉じる
  Serial.print("SPIFFS Read:");       // ⑬シリアルモニタにEEPROM内容表示
  Serial.println(readStr);
}

void loop(void){
}
