//  IoT電子工作キット sLab-Remo2
//  2-1-1.LED点滅

const byte LED_PIN = 12;        // ①利用ピンの設定（IO12にLED接続）

// ②起動時、最初に実行される処理
void setup() {
  pinMode(LED_PIN, OUTPUT);     // ③IO12に出力設定
}

// ④setup完了後、電源OFFまで繰り返し処理
void loop() {
  digitalWrite(LED_PIN, HIGH);  // ⑤LEDを点灯する
  delay(1000);                  // ⑥1秒間そのまま（点灯状態のまま）
  digitalWrite(LED_PIN, LOW);   // ⑦LEDを消灯する
  delay(1000);                  // ⑧1秒間そのまま（消灯状態のまま）
}
